﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading;

namespace pr249_1
{
    class Program
    {
        // Главный метод: 
        static void Main()
        {
            // Размер массива: 
            int size = 20;
            // Создание массива: 
            int[] ch = new int[size];
            // Заполнение массива нулями: 
            for (int k = 0; k < ch.Length; k++)
            {
                ch[k] = 0;
                Console.Write("|" + ch[k]);
            }
            Console.WriteLine("|");
            // Индекс первого и последнего элемента в массиве: 
            int first = 0, second = ch.Length - 1;
            // Объектные переменные для потоков:
            Thread A, B;
            // Создание объекта для первого потока:
            A = new Thread(() =>
            {
                // Начальный символ для заполнения массива: 
                int start = 1;
                // Бесконечный цикл: 
                while (true)
                {
                    // Если второй индекс больше первого индекса: 
                    if (second > first)
                    {
                        // Значение элемента: 
                        ch[second] = start;
                        // Новый символ для присваивания: 
                        start *= 3;
                        // Новое значение индекса: 
                        second--;
                        // Задержка в выполнении потока: 
                        Thread.Sleep(100);
                    }
                    // Если второй индекс не больше первого: 
                    else
                    {
                        // Завершение в выполнении потока: 
                        Thread.CurrentThread.Abort();
                    }
                }
            });

            // Создание объекта для второго потока:
            B = new Thread(() =>
            {
                // Начальный символ для заполнения массива: 
                int start = 1;
                // Бесконечный цикл: 
                while (true)
                {
                    // Если первый индекс меньше второго:
                    if (first < second)
                    {
                        // Значение элемента: 
                        ch[first] = start;
                        // Новый символ для присваивания: 
                        start *= 2;
                        // Новое значение индекса: 
                        first++;
                        // Задержка в выполнении потока: 
                        Thread.Sleep(100);
                    }
                    // Если первый индекс не меньше второго: 
                    else
                    {
                        // Завершение выполнения потока: 
                        Thread.CurrentThread.Abort();
                    }
                }
            });

            // Запуск первого потока на выполнение:
            A.Start();
            // Запуск второго потока на выполнение:
            B.Start();
            // Ожидание выполнения первого потока: 
            if (A.IsAlive) A.Join();
            // Ожидание выполнения второго потока: 
            if (B.IsAlive) B.Join();
            // Отображение содержимого массива: 
            for (int k = 0; k < ch.Length; k++)
            {
                Console.Write("|" + ch[k]);
            }
            Console.WriteLine("|");
        }

    }
}
